;; useful colors
(cond (window-system
       ;;
       (make-face 'red-bold)
       (set-face-foreground 'red-bold "red")
       (set-face-bold-p     'red-bold t)
       ;;
       (make-face 'red)
       (set-face-foreground 'red "red")
       ;;
       (make-face 'brown)
       (set-face-foreground 'brown "brown")
       ;;
       (make-face 'ForestGreen)
       (set-face-foreground 'ForestGreen "ForestGreen")
       ;;
       (make-face 'RoyalBlue)
       (set-face-foreground 'RoyalBlue "RoyalBlue")
       ;;
       (make-face 'MidnightBlue)
       (set-face-foreground 'MidnightBlue "MidnightBlue")
       ;;
       (make-face 'firebrick)
       (set-face-foreground 'firebrick "firebrick")
       ;;
       (make-face 'gray40)
       (set-face-foreground 'gray40 "gray40")
       ;;
       (make-face 'purple)
       (set-face-foreground 'purple "purple")
 ))

;; font-lock commands are similar for caml-mode and inferior-caml-mode
(setq caml-mode-hook
      '(lambda ()
	 (modify-syntax-entry ?_ "w" caml-mode-syntax-table)
	 (modify-syntax-entry ?' "w" caml-mode-syntax-table)
	 (modify-syntax-entry ?` "w" caml-mode-syntax-table)
	 (modify-syntax-entry ?: "w" caml-mode-syntax-table)
	 (cond (window-system
		(font-lock-mode 1)
		(setq font-lock-no-comments t)
		(setq font-lock-keywords
		      (list
;modules
		       '("\\<open\\>" 0 'brown)
		       '("\\<[A-Z][A-Za-z0-9_\']*\\>" 0 'MidnightBlue)
		       '("`[A-Za-z][A-Za-z0-9_\']*\\>" 0 'MidnightBlue)
;definition
		       (list (concat
			      "\\<\\(let\\|rec\\|in\\|type\\|of\\|and"
			      "\\|exception\\|val\\|and\\|function\\|fun"
			      "\\|parser\\|mutable\\|module\\|inherit"
			      "\\|external\\|method\\|virtual\\|private"
			      "\\|constraint\\|as\\|closed\\)\\>")
			 0 ''ForestGreen)
;blocking
		       '("\\<\\(class\\|struct\\|sig\\|begin\\|end\\)\\>"
			 0 'purple)
;control
		       (list (concat
			  "\\<\\(if\\|then\\|else\\|match\\|when"
			  "\\|with\\|try\\|for\\|do\\|while\\|done"
			  "\\|downto\\|to\\|or\\|new\\)\\>")
			 0 ''RoyalBlue) 
		       '("\|\\|->\\|&\\|#" 0 'RoyalBlue)
		       '("\\<raise\\>" 0 'red)
;labels
		       '("[?]?\\<[A-Za-z][A-Za-z0-9_\']*:"    0 'brown t)
		       '("[?]?\\<:[A-Za-z][A-Za-z0-9_\']*\\>"    0 'brown t)
;string
		       '("\'.?\'"                     0 'gray40 t)
		       '("\"[^\"]*\""                  0 'gray40 t)
;comments
		       '("(\\*.*\\*)"                  0 'firebrick t)))
		(font-lock-fontify-buffer)))))

(setq inferior-caml-mode-hooks
      '(lambda ()
	 (cond (window-system
		(font-lock-mode 1)
		(setq font-lock-no-comments t)
		(setq font-lock-keywords
		      (append
		       (list
;inferior
		       '("^[#-]"         0 'firebrick      )
;modules
		       '("\\<\\(open\\)\\>" 0 'brown)
		       '("\\<[A-Z][A-Za-z0-9_\']*\\>" 0 'MidnightBlue)
		       '("`[A-Za-z][A-Za-z0-9_\']*\\>" 0 'MidnightBlue)
;definition
		       (list (concat
			      "\\<\\(let\\|rec\\|in\\|type\\|of\\|and"
			      "\\|exception\\|val\\|and\\|function\\|fun"
			      "\\|parser\\|mutable\\|module\\|inherit"
			      "\\|external\\|method\\|virtual\\|private"
			      "\\|constraint\\|as\\|closed\\)\\>")
			 0 ''ForestGreen)
;blocking
		       '("\\<\\(class\\|struct\\|sig\\|begin\\|end\\)\\>"
			 0 'purple)
;control
		       (list (concat
			  "\\<\\(if\\|then\\|else\\|match\\|when"
			  "\\|with\\|try\\|for\\|do\\|while\\|done"
			  "\\|downto\\|to\\|new\\)\\>")
			 0 ''RoyalBlue) 
		       '("\|\\|->\\|&\\|#" 0 'RoyalBlue)
		       '("\\<raise\\>" 0 'red)
;labels
		       '("[?]?\\<[A-Za-z][A-Za-z0-9_\']*:"    0 'brown t)
		       '("[? \t]:[A-Za-z][A-Za-z0-9_\']*\\>"    0 'brown t)
;variants
		       '("`[A-Za-z][A-Za-z0-9_\']*"    0 'MidnightBlue t)
;string and char
		       '("\'.?\'"                      0 'grey40 t)
		       '("\"[^\"]*\""                  0 'grey40 t)
;comments
		       '("(\\*.*\\*)"                  0 'firebrick t))
		       font-lock-keywords))
		(font-lock-fontify-buffer)))))
